package LinearAlgebra;

final public class OnlineSampleStatisticsWeight extends OnlineSampleStatistics implements Weighted {
    double weight;

    public OnlineSampleStatisticsWeight() {
	Reset();
    }

    final public void Reset() {
	weight = 0;
    }

    final public void AddPoint(Vektor vektor) {
	try {
	    weight += ((Weighted)vektor).GetWeight();
	}
	catch (ClassCastException e) {
	    weight += 1;
	}
    }

    final public void DeletePoint(Vektor vektor) {
	try {
	    weight -= ((Weighted)vektor).GetWeight();
	}
	catch (ClassCastException e) {
	    weight -= 1;
	}
    }

    final public double GetWeight() {
	return weight;
    }
}
