package LinearAlgebra;

import java.awt.*;
import java.io.*;
import java.util.*;
import Paintable.*;

final public class Vektor2DWeighted extends Vektor2D implements PaintableWithChangingIntensity,Weighted {
    protected double weight;
    public static double maxWeight = 1.0; // for painting

    protected Vektor2DWeighted() {
	super();
	weight = 1;
    }

    public Vektor2DWeighted(double in_coordX,double in_coordY,double in_weight) {
	super(in_coordX,in_coordY);
	weight = in_weight;
    }

    public Vektor2DWeighted(StringTokenizer t) throws NoSuchElementException, NumberFormatException {
	super((new Double(t.nextToken())).doubleValue(),(new Double(t.nextToken())).doubleValue());
	weight = (new Double(t.nextToken())).doubleValue();
    }

    final public Vektor Clone() {
	return new Vektor2DWeighted(coordX,coordY,weight);
    }

    final public Vektor DefaultClone() {
	return new Vektor2DWeighted();
    }

    final public double GetWeight() {
	return weight;
    }

    final public void SetWeight(double in_weight) {
	weight = in_weight;
    }

    final public void Paint(Graphics g,DataCanvas canvas,int pixelSize,String type) {
	Color oldColor = g.getColor();
	g.setColor(new Color(ChangeRGBComponentIntensity(oldColor.getRed()),
			     ChangeRGBComponentIntensity(oldColor.getGreen()),
			     ChangeRGBComponentIntensity(oldColor.getBlue())));
	super.Paint(g,canvas,pixelSize,type);
	g.setColor(oldColor);
    }

    final public int ChangeRGBComponentIntensity(int c) {
	return (int)(255 - (255 - c)*weight/maxWeight);
    }

    final public String toString() {
	return super.toString() + "w = " + Utilities.MyMath.RoundDouble(weight,4);
    }

    final public void Save(PrintStream pOut) {
	super.Save(pOut);
	pOut.print(" " + weight);	
    }

    final public String SaveToString() {
	return super.SaveToString() + " " + weight;	
    }

}



