package LinearAlgebra;

import java.awt.*;
import java.io.*;
import java.util.*;

import Utilities.MyMath;
import Paintable.*;

final public class VektorDDLabeled extends VektorDD implements PaintableWithChangingIntensity {
    int label;
    public static int maxLabel = 256; //for painting

    protected VektorDDLabeled() {
	super();
	label = 0;
    }

    public VektorDDLabeled(int dimension,int in_label) {
	super(dimension);
	label = in_label;
    }

    public VektorDDLabeled(double [] in_coords,int in_label) {
	super(in_coords);
	label = in_label;
    }

    public VektorDDLabeled(Vektor vektor,int in_label) {
	super(vektor);
	label = in_label;
    }

    public VektorDDLabeled(StringTokenizer t) throws NoSuchElementException, NumberFormatException {
	super(t.countTokens() - 1);
	Constructor(t);
	label = (new Integer(t.nextToken())).intValue();
    }

    final public Vektor Clone() {
	return new VektorDDLabeled(coords,label);
    }

    final public Vektor DefaultClone() {
	return new VektorDDLabeled();
    }

    final public void SetLabel(int in_label) {
	label = in_label;
    }

    final public int GetLabel() {
	return label;
    }

    final public void Paint(Graphics g,DataCanvas canvas,int pixelSize,String type) {
	Color oldColor = g.getColor();
	g.setColor(new Color(ChangeRGBComponentIntensity(oldColor.getRed()),
			     ChangeRGBComponentIntensity(oldColor.getGreen()),
			     ChangeRGBComponentIntensity(oldColor.getBlue())));
	super.Paint(g,canvas,pixelSize,type);
	g.setColor(oldColor);
    }

    final public int ChangeRGBComponentIntensity(int c) {
	return 255 - ((255 - c)*label)/maxLabel;
    }

    final public String toString() {
	return super.toString() + "\t    label = " + label;
    }

}



